CREATE PROCEDURE [dbo].[SP_CapacityInsertDataSelection]
@SendMail char(1) 
AS
BEGIN
	BEGIN TRY
		DECLARE @DATEFROM DATETIME 
		SET @DATEFROM =(SELECT ISNULL(SYSTEM_VALUE,GETDATE()-7) FROM TB_M_SYSTEM WHERE FUNCTION_ID='CAPACITY_DATEFROM')
		DECLARE @DATETO DATETIME 
		SET @DATETO =(SELECT SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID='CAPACITY_DATETO')
		IF  ((@DATETO IS NULL) OR (@DATETO=''))
		BEGIN   
			DELETE FROM TB_V_CAPACITY_PLAN
			WHERE (PICKUP_DT > CONVERT(VARCHAR(10), @DATEFROM, 120))
			OR (PICKUP_DT >=GETDATE())
			
			INSERT INTO TB_V_CAPACITY_PLAN
			SELECT  
					NEWID(),
					ISNULL(DELIVERY_NO,'')
				  ,ISNULL(RCV_PLANT_CD,'')
				  ,ISNULL(ROUTE_CD,'')
				  ,ISNULL(ROUTE_SEQ,'')
				  ,ISNULL(PICKUP_DT,'')
				  ,ISNULL(LP_CD,'')
				  ,ISNULL(TRUCK_TYPE,'')
				  ,ISNULL(VOLUME_TARGET,0)
				  ,ISNULL(EFFICIENCY_TARGET,0)
				  ,ISNULL(UTILIZATION,0)
				  ,ISNULL(PERCENTAGE,0)
				  ,ISNULL([STATUS],'')
				  ,ISNULL(MANIFEST_NO,'') 
			FROM V_CAPACITY_PLAN
			WHERE (PICKUP_DT > CONVERT(VARCHAR(10), @DATEFROM, 120))
			OR (PICKUP_DT >=GETDATE())
		END
		ELSE
		BEGIN 
			DELETE FROM TB_V_CAPACITY_PLAN
			WHERE (PICKUP_DT BETWEEN CONVERT(VARCHAR(10), @DATEFROM, 120) AND CONVERT(VARCHAR(10), @DATETO, 120)) 
			INSERT INTO TB_V_CAPACITY_PLAN
			SELECT  
					NEWID()
					,ISNULL(DELIVERY_NO,'')
				  ,ISNULL(RCV_PLANT_CD,'')
				  ,ISNULL(ROUTE_CD,'')
				  ,ISNULL(ROUTE_SEQ,'')
				  ,ISNULL(PICKUP_DT,'')
				  ,ISNULL(LP_CD,'')
				  ,ISNULL(TRUCK_TYPE,'')
				  ,ISNULL(VOLUME_TARGET,0)
				  ,ISNULL(EFFICIENCY_TARGET,0)
				  ,ISNULL(UTILIZATION,0)
				  ,ISNULL(PERCENTAGE,0)
				  ,ISNULL([STATUS],'')
				  ,ISNULL(MANIFEST_NO,'') 
			FROM V_CAPACITY_PLAN
			WHERE (PICKUP_DT BETWEEN CONVERT(VARCHAR(10), @DATEFROM, 120) AND CONVERT(VARCHAR(10), @DATETO, 120))
		END 
		
		SELECT DISTINCT ROUTE_CD
		INTO #TMPA
		FROM TB_V_CAPACITY_PLAN
		WHERE [STATUS]='Not Master Entry'
		SELECT ROW_NUMBER() OVER(ORDER BY ROUTE_CD ASC) NOMOR,ROUTE_CD INTO #TMPB FROM #TMPA	
		
		DECLARE @MAXNUMB INT
		SELECT @MAXNUMB=MAX(NOMOR) FROM #TMPB  
		
		
		IF @SendMail='Y' AND @MAXNUMB<>0
		BEGIN
			DECLARE @CTR INT
			DECLARE @ROUTE VARCHAR(10)
			DECLARE @BODYMAIL VARCHAR (MAX)
			
			SET @CTR=1
			SET @BODYMAIL='<table border="1"> <tr><td>No</td> <td>ROUTE CODE</td> </tr>'
					
			WHILE (@CTR <= @MAXNUMB)
				BEGIN 
					SELECT @ROUTE=ROUTE_CD FROM #TMPB WHERE NOMOR=@CTR
					SET @BODYMAIL=@BODYMAIL+'<tr><td>'+CONVERT(varchar(10),@CTR)+'</td><td>'+ CONVERT(varchar(10),@ROUTE) +'</td></tr>'
				SET @CTR=@CTR+1
				END
			SET @BODYMAIL=@BODYMAIL+'</table>' 
			
			DECLARE @RECIPIENT VARCHAR (100)
			DECLARE @CC VARCHAR (100)
			--SET @RECIPIENT='yoppie@toyota.co.id'
			SELECT @RECIPIENT=SYSTEM_VALUE FROM dbo.TB_M_SYSTEM WHERE FUNCTION_ID='CAPACITY_RECIPIENT'
			SELECT @CC=SYSTEM_VALUE FROM dbo.TB_M_SYSTEM WHERE FUNCTION_ID='CAPACITY_CC'
			
			EXEC SP_CapacitySendMailAll @RECIPIENT,@CC,'NOT ENTRY MASTER TRUCK CAPACITY',@BODYMAIL
		END
		
		DROP TABLE #TMPA 
		DROP TABLE #TMPB
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=1 WHERE FUNCTION_ID='CAPACITY_BTNCEK'
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=NULL WHERE FUNCTION_ID='CAPACITY_DATETO'
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=NULL WHERE FUNCTION_ID='CAPACITY_DATEFROM'
	END TRY
	BEGIN CATCH 
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=1 WHERE FUNCTION_ID='CAPACITY_BTNCEK'
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=NULL WHERE FUNCTION_ID='CAPACITY_DATETO'
		UPDATE TB_M_SYSTEM SET SYSTEM_VALUE=NULL WHERE FUNCTION_ID='CAPACITY_DATEFROM'
	END CATCH
END

